<template>
  <div>
    <h2 id="page-heading" data-cy="UtilisateurHeading">
      <span v-text="$t('coopcycleApp.utilisateur.home.title')" id="utilisateur-heading">Utilisateurs</span>
      <div class="d-flex justify-content-end">
        <button class="btn btn-info mr-2" v-on:click="handleSyncList" :disabled="isFetching">
          <font-awesome-icon icon="sync" :spin="isFetching"></font-awesome-icon>
          <span v-text="$t('coopcycleApp.utilisateur.home.refreshListLabel')">Refresh List</span>
        </button>
        <router-link :to="{ name: 'UtilisateurCreate' }" custom v-slot="{ navigate }">
          <button
            @click="navigate"
            id="jh-create-entity"
            data-cy="entityCreateButton"
            class="btn btn-primary jh-create-entity create-utilisateur"
          >
            <font-awesome-icon icon="plus"></font-awesome-icon>
            <span v-text="$t('coopcycleApp.utilisateur.home.createLabel')"> Create a new Utilisateur </span>
          </button>
        </router-link>
      </div>
    </h2>
    <br />
    <div class="alert alert-warning" v-if="!isFetching && utilisateurs && utilisateurs.length === 0">
      <span v-text="$t('coopcycleApp.utilisateur.home.notFound')">No utilisateurs found</span>
    </div>
    <div class="table-responsive" v-if="utilisateurs && utilisateurs.length > 0">
      <table class="table table-striped" aria-describedby="utilisateurs">
        <thead>
          <tr>
            <th scope="row" v-on:click="changeOrder('id')">
              <span v-text="$t('global.field.id')">ID</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'id'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('nomUtilisateur')">
              <span v-text="$t('coopcycleApp.utilisateur.nomUtilisateur')">Nom Utilisateur</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'nomUtilisateur'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('age')">
              <span v-text="$t('coopcycleApp.utilisateur.age')">Age</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'age'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('addresse')">
              <span v-text="$t('coopcycleApp.utilisateur.addresse')">Addresse</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'addresse'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('role')">
              <span v-text="$t('coopcycleApp.utilisateur.role')">Role</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'role'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('course.id')">
              <span v-text="$t('coopcycleApp.utilisateur.course')">Course</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'course.id'"></jhi-sort-indicator>
            </th>
            <th scope="row"></th>
          </tr>
        </thead>
        <tbody>
          <tr v-for="utilisateur in utilisateurs" :key="utilisateur.id" data-cy="entityTable">
            <td>
              <router-link :to="{ name: 'UtilisateurView', params: { utilisateurId: utilisateur.id } }">{{ utilisateur.id }}</router-link>
            </td>
            <td>{{ utilisateur.nomUtilisateur }}</td>
            <td>{{ utilisateur.age }}</td>
            <td>{{ utilisateur.addresse }}</td>
            <td v-text="$t('coopcycleApp.Role.' + utilisateur.role)">{{ utilisateur.role }}</td>
            <td>
              <div v-if="utilisateur.course">
                <router-link :to="{ name: 'CourseView', params: { courseId: utilisateur.course.id } }">{{
                  utilisateur.course.id
                }}</router-link>
              </div>
            </td>
            <td class="text-right">
              <div class="btn-group">
                <router-link :to="{ name: 'UtilisateurView', params: { utilisateurId: utilisateur.id } }" custom v-slot="{ navigate }">
                  <button @click="navigate" class="btn btn-info btn-sm details" data-cy="entityDetailsButton">
                    <font-awesome-icon icon="eye"></font-awesome-icon>
                    <span class="d-none d-md-inline" v-text="$t('entity.action.view')">View</span>
                  </button>
                </router-link>
                <router-link :to="{ name: 'UtilisateurEdit', params: { utilisateurId: utilisateur.id } }" custom v-slot="{ navigate }">
                  <button @click="navigate" class="btn btn-primary btn-sm edit" data-cy="entityEditButton">
                    <font-awesome-icon icon="pencil-alt"></font-awesome-icon>
                    <span class="d-none d-md-inline" v-text="$t('entity.action.edit')">Edit</span>
                  </button>
                </router-link>
                <b-button
                  v-on:click="prepareRemove(utilisateur)"
                  variant="danger"
                  class="btn btn-sm"
                  data-cy="entityDeleteButton"
                  v-b-modal.removeEntity
                >
                  <font-awesome-icon icon="times"></font-awesome-icon>
                  <span class="d-none d-md-inline" v-text="$t('entity.action.delete')">Delete</span>
                </b-button>
              </div>
            </td>
          </tr>
        </tbody>
        <infinite-loading
          ref="infiniteLoading"
          v-if="totalItems > itemsPerPage"
          :identifier="infiniteId"
          slot="append"
          @infinite="loadMore"
          force-use-infinite-wrapper=".el-table__body-wrapper"
          :distance="20"
        >
        </infinite-loading>
      </table>
    </div>
    <b-modal ref="removeEntity" id="removeEntity">
      <span slot="modal-title"
        ><span id="coopcycleApp.utilisateur.delete.question" data-cy="utilisateurDeleteDialogHeading" v-text="$t('entity.delete.title')"
          >Confirm delete operation</span
        ></span
      >
      <div class="modal-body">
        <p id="jhi-delete-utilisateur-heading" v-text="$t('coopcycleApp.utilisateur.delete.question', { id: removeId })">
          Are you sure you want to delete this Utilisateur?
        </p>
      </div>
      <div slot="modal-footer">
        <button type="button" class="btn btn-secondary" v-text="$t('entity.action.cancel')" v-on:click="closeDialog()">Cancel</button>
        <button
          type="button"
          class="btn btn-primary"
          id="jhi-confirm-delete-utilisateur"
          data-cy="entityConfirmDeleteButton"
          v-text="$t('entity.action.delete')"
          v-on:click="removeUtilisateur()"
        >
          Delete
        </button>
      </div>
    </b-modal>
  </div>
</template>

<script lang="ts" src="./utilisateur.component.ts"></script>
